import { Injectable } from '@angular/core';
import { Effect, Actions, ofType } from '@ngrx/effects';
import { of } from 'rxjs';
import { catchError, exhaustMap, map, tap } from 'rxjs/operators';

import { MetaProbeTaskType } from '@overflow/commons-typescript/model/meta';

import { MetaProbeTaskTypeService } from '../../../service/meta-probe-task-type.service';

import {
  ReadAll,
  ReadAllSuccess,
  ReadAllFailure,
  ActionType,
} from './meta-probe-task-type.action';

@Injectable()
export class Effects {

  constructor(
    private actions$: Actions,
    private metaProbeTaskTypeService: MetaProbeTaskTypeService,
  ) { }

  @Effect()
  readAll$ = this.actions$.pipe(
    ofType(ActionType.ReadAll),
    exhaustMap(() =>
      this.metaProbeTaskTypeService
        .readAll()
        .pipe(
          map((result: MetaProbeTaskType[]) => {
            return new ReadAllSuccess(result);
          }),
          catchError(error => of(new ReadAllFailure(error)))
        )
    )
  );
}
